# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PolicyDecisionObjectNode(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'type_id': 'str',
        'policies': 'list[PolicyDecisionObjectNodePolicies]',
        'org_id': 'str',
        'project_id': 'str',
        'target_id': 'str',
        'target_name': 'str',
        'timestamp': 'datetime',
        'description': 'str',
        'effective_policy_definition': 'object',
        'dry_run_id': 'str',
        'dry_run_sub_task_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'type_id': 'typeId',
        'policies': 'policies',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'target_id': 'targetId',
        'target_name': 'targetName',
        'timestamp': 'timestamp',
        'description': 'description',
        'effective_policy_definition': 'effectivePolicyDefinition',
        'dry_run_id': 'dryRunId',
        'dry_run_sub_task_id': 'dryRunSubTaskId'
    }

    def __init__(self, id=None, type_id=None, policies=None, org_id=None, project_id=None, target_id=None, target_name=None, timestamp=None, description=None, effective_policy_definition=None, dry_run_id=None, dry_run_sub_task_id=None):  # noqa: E501
        """PolicyDecisionObjectNode - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._type_id = None
        self._policies = None
        self._org_id = None
        self._project_id = None
        self._target_id = None
        self._target_name = None
        self._timestamp = None
        self._description = None
        self._effective_policy_definition = None
        self._dry_run_id = None
        self._dry_run_sub_task_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if type_id is not None:
            self.type_id = type_id
        if policies is not None:
            self.policies = policies
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if target_id is not None:
            self.target_id = target_id
        if target_name is not None:
            self.target_name = target_name
        if timestamp is not None:
            self.timestamp = timestamp
        if description is not None:
            self.description = description
        if effective_policy_definition is not None:
            self.effective_policy_definition = effective_policy_definition
        if dry_run_id is not None:
            self.dry_run_id = dry_run_id
        if dry_run_sub_task_id is not None:
            self.dry_run_sub_task_id = dry_run_sub_task_id

    @property
    def id(self):
        """Gets the id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PolicyDecisionObjectNode.


        :param id: The id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type_id(self):
        """Gets the type_id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The type_id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._type_id

    @type_id.setter
    def type_id(self, type_id):
        """Sets the type_id of this PolicyDecisionObjectNode.


        :param type_id: The type_id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._type_id = type_id

    @property
    def policies(self):
        """Gets the policies of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The policies of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: list[PolicyDecisionObjectNodePolicies]
        """
        return self._policies

    @policies.setter
    def policies(self, policies):
        """Sets the policies of this PolicyDecisionObjectNode.


        :param policies: The policies of this PolicyDecisionObjectNode.  # noqa: E501
        :type: list[PolicyDecisionObjectNodePolicies]
        """

        self._policies = policies

    @property
    def org_id(self):
        """Gets the org_id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The org_id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PolicyDecisionObjectNode.


        :param org_id: The org_id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The project_id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this PolicyDecisionObjectNode.


        :param project_id: The project_id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def target_id(self):
        """Gets the target_id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The target_id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._target_id

    @target_id.setter
    def target_id(self, target_id):
        """Sets the target_id of this PolicyDecisionObjectNode.


        :param target_id: The target_id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._target_id = target_id

    @property
    def target_name(self):
        """Gets the target_name of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The target_name of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._target_name

    @target_name.setter
    def target_name(self, target_name):
        """Sets the target_name of this PolicyDecisionObjectNode.


        :param target_name: The target_name of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._target_name = target_name

    @property
    def timestamp(self):
        """Gets the timestamp of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The timestamp of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this PolicyDecisionObjectNode.


        :param timestamp: The timestamp of this PolicyDecisionObjectNode.  # noqa: E501
        :type: datetime
        """

        self._timestamp = timestamp

    @property
    def description(self):
        """Gets the description of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The description of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PolicyDecisionObjectNode.


        :param description: The description of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def effective_policy_definition(self):
        """Gets the effective_policy_definition of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The effective_policy_definition of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: object
        """
        return self._effective_policy_definition

    @effective_policy_definition.setter
    def effective_policy_definition(self, effective_policy_definition):
        """Sets the effective_policy_definition of this PolicyDecisionObjectNode.


        :param effective_policy_definition: The effective_policy_definition of this PolicyDecisionObjectNode.  # noqa: E501
        :type: object
        """

        self._effective_policy_definition = effective_policy_definition

    @property
    def dry_run_id(self):
        """Gets the dry_run_id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The dry_run_id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._dry_run_id

    @dry_run_id.setter
    def dry_run_id(self, dry_run_id):
        """Sets the dry_run_id of this PolicyDecisionObjectNode.


        :param dry_run_id: The dry_run_id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._dry_run_id = dry_run_id

    @property
    def dry_run_sub_task_id(self):
        """Gets the dry_run_sub_task_id of this PolicyDecisionObjectNode.  # noqa: E501


        :return: The dry_run_sub_task_id of this PolicyDecisionObjectNode.  # noqa: E501
        :rtype: str
        """
        return self._dry_run_sub_task_id

    @dry_run_sub_task_id.setter
    def dry_run_sub_task_id(self, dry_run_sub_task_id):
        """Sets the dry_run_sub_task_id of this PolicyDecisionObjectNode.


        :param dry_run_sub_task_id: The dry_run_sub_task_id of this PolicyDecisionObjectNode.  # noqa: E501
        :type: str
        """

        self._dry_run_sub_task_id = dry_run_sub_task_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PolicyDecisionObjectNode, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PolicyDecisionObjectNode):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
